\ 3iMusic-scales.fs
\ Assad Ebrahim

\ For References, see below
\ For Theory, see below

\ for core creation words see help-scales or 3iSound-4x4.fs

\ WESTERN SCALES
\ cstd, 0 sharps and flats

create fmaj8  C_ D_ E_ F_ G_ A_ B%_ C'  8 save-scale
: fmaj  
    cr ." F major - 1 flat B%"
    cr 
    fmaj8 load-scale ;
: 1flat fmaj ;

create b%maj8 C_ D_ E%_ F_ G_ A_ B%_ C' 8 save-scale
: b%maj 
    cr ." B% major - 2 flats B% E%"
    cr
    b%maj8 load-scale ;
: 2flats  b%maj ;

create e%maj8   C_ D_ e%_ f_ g_ a%_ b%_ c'       8 save-scale
: e%maj  
    cr ." E% major - 3 flats  B% E% A%"
    cr 
    e%maj8  load-scale ;
: 3flats e%maj ;


create a%maj8   C_ d%_ e%_ f_ g_ a%_ b%_ c'       8 save-scale
: a%maj  
    cr ." A% major - 4 flats  B% E% A% D%"
    cr 
    a%maj8  load-scale ;
: 4flats a%maj ;

create a%maj8C   c_ e%_ f_ g_ a%_ b%_ c' d%'       8 save-scale
: a%majA  a%maj8c  load-scale ;
: 4flats-stairway a%majA ;  \ starts at f but include low c for stairway to heaven
\ repertoire: stairway to heaven on 3, or back to life on 1


\ 5flats is Db major - tuned on A -- five flats on D, E, G, A, B) with only C and F undecorated
\ It is close to todi raga scale key but with F/F# and G%/G
create d%maj8   C_ d%_ e%_ f_ g%_ a%_ b%_ c'      8 save-scale
: d%maj 
    cr ." D% major - 5 flats B% E% A% D% G%"
    cr
    d%maj8 load-scale ;
: 5flats d%maj ;
: 5flats-dream  
    cr ." cycles d%maj two notes to start at a%_"  \ Note - this is NOT -4 semitones transposition of d%maj
    cr ."    for: I have a dream"
    cr ."    (a%__ b%__ C_ d%_ e%_ F_ g%_ a%_)"
    cr 
    d%maj8 7 2 cycle-scale ;


\ 1 sharp
create   gmaj8 C_   D_   E_   F#_    G_    A_    B_    C'  8 save-scale
: gmaj   
    cr ." G major - 1 sharp F#"
    cr 
gmaj8 load-scale ;

\ 2 sharps
create   dmaj8 C#_   D_   E_   F#_    G_    A_    B_    C#'  8 save-scale
: dmaj   
    cr ." D major - 2 sharps F# C#"
    cr 
dmaj8 load-scale ;

\ 3 sharps
create   amaj8 C#_   D_   E_   F#_    G#_    A_    B_    C#'  8 save-scale
: amaj   
    cr ." A major - 3 sharps F# C# G#"
    cr 
amaj8 load-scale ;

\ 4 sharps
create   emaj8 C#_   D#_   E_   F#_    G#_    A_    B_    C#'  8 save-scale
: emaj   
    cr ." E major - 4 sharps F# C# G# D#"
    cr 
emaj8 load-scale ;

\ 5 sharps
create   bmaj8 C#_   D#_   E_   F#_    G#_    A#_    B_    C#'  8 save-scale
: bmaj   
    cr ." B major - 5 sharps F# C# G# D# A#"
    cr 
bmaj8 load-scale ;


\ Pentatonic scales
\ Cmaj8 starts on G  She'll be coming round the mountain when she comes...   O! Susanna (start on 3)
create c5maj8      G__ A__ C_ D_ E_ G_ A_ C'          8  save-scale
: c5maj  
    cr ." C Pentatonic Major: g__ a__ c_ d_ e_ g_ a_ c'"
    cr 
c5maj8 load-scale ;                          
       
\ Beautiful melancholy scale       
create dmin8      D_ E_ F_ G_ A_ b%_ c#' D'          8 save-scale
: dmin  
    cr ." D minor: d_ e_ f_ g_ a_ b%_ c#' d'"
    cr 
dmin8 load-scale ;                          
                                                    
                                                    
\ NON-WESTERN SCALES (with equal-tempered notes)

: irish  2flats ;
\ Sean nos - old style irish singing -- Madelyn Monaghan
\  Galway style - https://youtu.be/2zCv3XXjCY8?t=240
\             https://youtu.be/2zCv3XXjCY8?t=353
\  West Kerry - https://youtu.be/2zCv3XXjCY8?t=261
\  Donegal - https://youtu.be/2zCv3XXjCY8?t=280
\  Waterford - https://youtu.be/2zCv3XXjCY8?t=295

\ bluegrass:  https://www.cs.mcgill.ca/~rwest/wikispeedia/wpcd/wp/b/Bluegrass_music.htm
: bluegrass 2flats ;
\ Betty Jean Robinson and the Nashville Grass: Tramp on the Street: https://www.youtube.com/watch?v=oIrPSO7OWbc&t=416s
\ Dixie Chick origins: https://en.wikipedia.org/wiki/The_Chicks
\ Truck Driving Queen: 
\ Take Me Home Country Roads: https://www.youtube.com/watch?v=qap9Qm-Q894
\ Jolene: https://www.youtube.com/watch?v=viQx4KDivPY
\ https://www.youtube.com/watch?v=oIrPSO7OWbc             
                                                     

                                                     
\ INDIAN SCALES: Sa Re Ga Ma Pa Dha Ni Sa
\ Source: Special Topics in Music Theory, by Catherine Schmidt-Jones, Ch. 3.5 Indian Classical Music: Tuning and Ragas
\   https://cnx.org/contents/mviDomhA@5.66:bDLyHWWs@16/Indian-Classical-Music-Tuning-and-Ragas
\ A "that" is a scale of 7 notes -- why 7?  (7 celestial bodies - Sun, Moon, Mercury, Venus, Mars, Jupiter and Saturn)
\ Aside: 7 days a week: Babylonians of the 6th century... https://www.discovermagazine.com/planet-earth/why-are-there-seven-days-in-a-week
\ A raga chooses five, six, or all 7 notes of the that, and sticks to that, i.e. pentatonic raga, hexatonic raga, or full raga

\ FULL RAGAS
\ Double harmonic major = bhairav raga = byzantine = gypsy major = hijaz kar maqam
\ bhairav = full raga with two flats on D and A     NO EQUIVALENT WESTERN MAJOR SCALE
\ https://en.wikipedia.org/wiki/Double_harmonic_scale
\ also arabic maqam - Hijaz Kar maqam - https://www.pianoscales.org/maqams.html
\ Arabic Maqam scales: https://www.traditionalarabicmusic.com/Music%20Structure/Quarter%20tone.htm
create      bhairav8   C_  d%_  E_  F_  G_  a%_  B_  C'  8 save-scale   \ 1 2 5 6   8 9 12 13
: bhairav   
    cr ." Bhairav (Indian): c d% e f g a% b c' "
    cr
    bhairav8 load-scale ;
: hijaz-kar bhairav ; \ arabic maqam
: byzantine bhairav ;

create     bhairavG8  G__ a%__ B__ C_  D_  e%_  f#_  G_  8 save-scale  \ transposed 5 semitones down to G
: bhairavG bhairavG8 load-scale ;

create     spanishgypsy8 c_ d%_ e_ f_ g_ a%_ b%_ c' 8 save-scale
: spanishgypsy  
    cr ." Spanish Gypsy: c_ d%_ e_ f_ g_ a%_ b%_ c' "
    cr
spanishgypsy8 load-scale ;

\ Hungarian/gypsy minor
\ https://en.wikipedia.org/wiki/Double_harmonic_scale#Modes
create gypsyminor8  c_ d_ e%_ f#_ g_ a%_ b_ c' 8 save-scale 
: gypsyminor 
    cr ." Gypsy Minor: c_ d_ e%_ f#_ g_ a%_ b_ c' "
    cr
    gypsyminor8 load-scale ; 

\ Ukrainian Dorian scale (also a Jewish scale)
\ https://en.wikipedia.org/wiki/Ukrainian_Dorian_scale
create ukrainian8 c_ d_ e%_ f#_ g_ a_ b%_ c'  8 save-scale 
: ukrainian
   cr ." Ukrainian c d e% f#  g a b% c' "
   cr
   ukrainian8 load-scale ; 
   
\ Arabic Music: http://www.maqamworld.com/en/index.php
\ Arabic & N. African music require quarter tones for proper intonation
\ Quarter-tone guitar: https://www.revelationguitars.co.uk/guitar/marrakesh-quarter-tone/
\ Jins (Notes) and Maqams (Scales)
\ JINS: http://www.maqamworld.com/en/jins.php
create hijaz8  D_ E%_ F#_ G_   A_ B%_ C#' D' 8 save-scale  \ 1 3 1 2.    Similar to ukrainian scale but with extra sharp on C
: jins-hijaz 
    cr ." Jins-Hijaz: d_ e%_ f#_ g_  a_ b%_ c#' d'"
    cr
    hijaz8 load-scale ;



\ purvi   = raga with 1 sharp on F and two flats on D and A,    NO EQUIVALENT WESTERN MAJOR SCALE   ex: "back to life, back to reality"
            \  (close to A-MAJOR although the 3 decorated notes are also 3 sharps on F, C, G,  the scale also has C and G natural)
create purvi8   C_    d%_     E_    f#_    G_    a%_    B_    C' 8 save-scale
: purvi  
    cr ." Purvi (Indian): c d% e f# g a% b c' "
    cr
    purvi8 load-scale ; 

\ todi  = it's a bhairavi raga (four flats on B, E, A, D ) with additionally 1 sharp on F  NO EQUIVALENT IN WESTERN SCALE
            \ (close to D%-MAJ  -- the f# is taken as G%, but also preserves the G natural )
create todi8   a%__   b%__   C_     d%_    e%_     f#_     G_     A%_  8 save-scale  \ starting at A%
: todi  
    cr ." Todi (Indian raga): a% b% c d% e% f# g a% "
    cr
    todi8 load-scale ;
create todiC8   C_    d%_    e%_    f#_    G_    a%_    b%_    C'   8 save-scale
: todiC  todiC8 load-scale ;


\ khamaj = raga with 1 flat on B                    EQUIVALENT TO F MAJOR
: khamaj fmaj ;

\ kafi  = raga with two flats on B and E            EQUIVALENT TO B%-MAJ   ex: unchaare kot 3rd note, aaj aanand 1st note, and scarborough fair
: kafi  b%maj ;

\ asavari  = raga with three flats on B, E, A       EQUIVALENT TO E%-MAJ
: asavari  e%maj ; 

\ bhairavi  = raga with four flats on B, E, A, D    EQUIVALENT TO A%-MAJ
: bhairavi  a%maj ;

\ kalyan  = raga with 1 sharp on F   WESTERN: G MAJOR
: kalyan gmaj ; 
   
\ bilawal = =raga with no flats or sharps, ex: abadoo (on C) and doh-a-deer  \ Western C-major 
create bilawal8  G__ A__ B__ C_ D_ E_ F_ G_  8 save-scale  \ transposed to G  ex: abadoo starting on 4
: bilawal bilawal8  load-scale ; 


\ ALGERIAN: https://www.pianoscales.org/algerian.html
\ Example algerian electric guitar: https://www.guitar9.com/column/why-does-scale-sound-exotic
\  2 1 2  1 1 1  3 1
create algerian8  ( D_ ) E_ F_ G_ A%_ A_ B%_ C#' D'  8 save-scale
: algerian  
    cr ." Algerian: e_ f_ g_ a%_   a_ b%_ c#' d' "
    cr
    algerian8 load-scale ;



\ this is 2 flats, starting on D
create kurd8 D_ E%_ F_ G_   A_ B%_ C' D' 8 save-scale    \ 1 1.5 .5 2   \ 2nd note tuned high, third note tuned low
: jins-kurd  kurd8 load-scale ;

\ this is 3 flats starting on D
create lami8 D_ E%_ F_ G_   A%_ B%_ C' D' 8 save-scale
: jins-lami lami8 load-scale ;

\ pentatonic
create selisir8  C' D%' E%' G' A%' C'' D%'' E%'' 8 save-scale  \ pentatonic scale (no B yet 3 flats) -- raised octave for pipes sound
: balinese 
    cr ." Balinese: c' d%' d%' g' a%' c'' d%'' e%'' "
    cr 
    selisir8  load-scale ;
\ pentatonic
create chinese8  C_ E_ F#_ G_ B_ C' E' F#' 8 save-scale
: chinese chinese8 load-scale ;

\ this pentatonic cmaj but starting at C
create mongolian8  C_ D_ E_ G_ A_ C' D' E' 8 save-scale  \ this is the yu scale shifted down 4 positions to start on C
: mongolian mongolian8 load-scale ;

\ this is pentatonic cmaj but starting at A
create yu8-approx A_ C' D' E' G' A' C'' D'' 8 save-scale
: yu-approx  
  cr ." Yu is a Chinese pentatonic scale that uses non-western note frequencies."
  cr ." This scale approximates it using western notes."
  cr ."   A_ C' D' E' G'    A' C'' D'' "
  yu8-approx load-scale ;

\  EXOTIC SCALES have non-western FREQUENCIES

\ e.g. scales with intervals shorter than a half-step: https://www.guitar9.com/column/why-does-scale-sound-exotic
\ Sruti (Indian)
\ Jins (Arabic)

\ CHINESE SCALES:  Nanyin performance: http://2centsmusic.blogspot.com/2011/05/nanyin.html
\ Theory: https://web.archive.org/web/20131009041743/http://2centsmusic.blogspot.se/2011/04/tonality-and-scales-in-chinese-music.html
\ Yu scale on Huang Zhong base freq ( Why Don't you come back... and Fire on the Mountain)

\ TODO: ? the 5 celestial harmonies ?

create yu8  yu-root save-exotic-scale
: yu  
    cr ." Yu (Chinese) "
    cr
yu8 load-scale ;
\ shang from note 4 is like yu but higher
create shang8  shang-root save-exotic-scale
: shang  
    cr ." Shang (Chinese) "
    cr
shang8 load-scale ;
\ gong is like the western scale, starting at D, but with different base frequencies, and skipping C F the undecorated notes in d%maj (5 flats)
create gong8   gong-root save-exotic-scale
: gong   
    cr ." Gong (Chinese) "
    cr
gong8 load-scale ;
\ Jue from note 3 is like yu but higher
create jue8  jue-root save-exotic-scale
: jue  
    cr ." Jue (Chinese) "
    cr
jue8  load-scale ; 
\ Zhi from note 2 is like yu
create zhi8  zhi-root save-exotic-scale
: zhi  
    cr ." Zhi (Chinese) "
    cr
zhi8  load-scale ;


\ ===== Japanese
\ https://japanhistorymusic.weebly.com/japanese-music-theory.html

\ this is pentatonic cmaj
create yo8     g__ a__ c_ d_ e_ g_ a_ c' 8 save-scale
\ pentatonic GBCEF
create ryuku8  g__ b__ c_ e_ f_ g_ b_ c' 8 save-scale
create injap8  b__ c_ e_ f_ a_ b_ c' e'  8 save-scale
create kongo8  b__ d_ e_ f_ a_ b_ d' e'  8 save-scale
: yo    
    cr ." Yo (Japanese): g__ a__ c_ d_ e_ g_ a_ c'"
    cr
yo8        load-scale ;
create ritsu8   c_ d_ e_ g_ a_ c' d' e' 8 save-scale
: ritsu  
    cr ." Ritsu (Japanese): c_ d_ e_ g_ a_ c' d' e'"
    cr
ritsu8  load-scale ;

: ryuku 
    cr ." Ryuku (Japanese): g__ b__ c_ e_ f_ g_ b_ c'"
    cr
ryuku8  load-scale ;

: injap 
    cr ." In (Japanese): b__ c_ e_ f_ a_ b_ c' e'"
    cr
injap8  load-scale ;

\ this is injap rotated left 1 position
create sakura8  c_ e_ f_ a_ b_ c' e' f'  8 save-scale
: sakura  
    cr ." Sakura (Japanese): c_ e_ f_ a_ b_ c' e' f'"
    cr
sakura8 load-scale ;

: kongo 
    cr ." In (Japanese): b__ d_ e_ f_ a_ b_ d' e'"
    cr
kongo8  load-scale ;

create hirajoshi8  g__ a%__ c_ d_ e%_ g_ a%_ c'  8 save-scale
: hirajoshi  
    cr ." Hirajoshi (Japanese): g__ a%__ c_ d_ e%_ g_ a%_ c'"
    cr
hirajoshi8  load-scale ;



\ ================ APPLICATION - string instrument tunings
\ Instrument tunings: https://onlinetonegenerator.com/tuning.html
create guitar6  E__ A__ D_ G_ B_ E' 6 save-scale 
: guitar  
    cr ." Guitar tuning: E__ A__ D_ G_ B_ E' "
    cr ."  (Every Awesome Duck Gives Big Eggs)"
    cr    
    guitar6 load-scale ;
create bass4    E___ A___ D__ G__ 4 save-scale  \ first 4 are bass strings, 1 octave lower than the bass of a 6-string guitar
: bass    
    cr ." Bass tuning: E___ A___ D__ G__ " 
    cr ."   (Every Awesome Duck Gives)"
    cr
    bass4   load-scale ;
create ukelele4 G_ C_ E_ A_ 4 save-scale     \ top G(4) C(3) E(2) A(1) highest - soprano/concert ukelele, next 4 are given an octave higher
: ukelele  
    cr ." Ukelele tuning: G_ C_ E_ A_ "
    cr ."  (Good Camels Eat Apples)"
    cr 
    ukelele4 load-scale ;
create violin4  G__ D_ A_ E' 4 save-scale   \ first note is lowest string of viola, then violin 4 notes
: violin  
    cr ." Violin tuing: G__ D_ A_ E' "
    cr ."   (Good Ducks Are Excellent)"
    cr 
    violin4 load-scale ; 
create cello4  C___ G___ D__ A__ 4 save-scale \ cello are an octave lower than viola, same notes.  Cellos are in the same octave as bass guitar
: cello  
    cr ." Cello tuning: C___ G___ D__ A__ "  
    cr ."   (Crazy Good Duck Action)"
    cr  
    cello4 load-scale ;
: viola    \ viola is cello an octave higher
    cr ." Viola tuning: C__ G__ D_ A_ "
    cr ."   (Crazy Good Duck Action)"
    cello4 12 transpose-scale load-scale ;
\ Banjo tunings: https://www.deeringbanjos.com/pages/how-to-tune-a-banjo
\   tones: https://www.youtube.com/watch?v=C1KoKrHvkig
create banjo5  G' D_ G_ B_ D' 5 save-scale 
: banjo  
    cr ." Banjo tuning: G' D_ G_ B_ D' "
    cr ."  (Good Ducks Get Banjo Disease)"
    cr    
    banjo5 load-scale ;
\ Harmonica tunings are particularly complicated as they feature blow and draw notes that are different!
\ https://theharmonicacompany.com/harmonica-tunings-explained/?v=79cba1185463



create scales
  ' cstd      ,   ' fmaj       ,  ' b%maj       ,  ' e%maj         ,
  ' a%maj     ,   ' d%maj      ,  ' gmaj        ,  ' dmaj          ,
  ' amaj      ,   ' emaj       ,  ' bmaj        ,  ' c5maj         ,
  ' dmin      ,   ' irish      ,  ' balinese    ,  ' spanishgypsy  ,

  ' bhairav   ,   ' gypsyminor ,  ' ukrainian   ,  ' jins-hijaz    ,  
  ' purvi     ,   ' todi       ,  ' algerian    ,  ' jins-kurd     ,
  ' yu        ,   ' shang      ,  ' gong        ,  ' jue           ,
  ' zhi       ,   ' hirajoshi  ,  ' sakura      ,  ' ritsu         ,
  
  ' yo        ,   ' injap      ,  ' kongo       ,  ' ryuku         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 

create tuner
  ' guitar    ,   ' ukelele    ,  ' banjo       ,  ' bass          ,
  ' violin    ,   ' viola      ,  ' cello       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 
  ' dummy     ,   ' dummy      ,  ' dummy       ,  ' dummy         , 

  
: [scalelist]
  cr
  cr ." LIST A:"
  cr ."   cstd              fmaj (1% b)      b%maj(2% be)    e%maj(3% bea)"
  cr ."   a%maj(4% bead)    d%maj(5% beadg)  gmaj (1# f)     dmaj (2# fc) "
  cr ."   amaj (3# fcg)     emaj (4# fcgd)   bmaj (5# fcgda) c5maj(cdega) "
  cr ."   dmin (defgab%c#d) irish/bluegrass  balinese        spanishgypsy "
  cr ." LIST B:"
  cr ."   bhairav           gypsyminor       ukrainian       jins-hijaz "
  cr ."   purvi             todi             algerian        jins-kurd  "
  cr ."   yu                shang            gong            jue        "
  cr ."   zhi               hirajoshi        sakura          ritsu      "
  cr ." LIST C:"
  cr ."   yo                injap            kongo           ryuku      "
  cr ."   Rest are empty scales "
  cr ." LIST D:"
  cr ."   Empty scales "
  cr
;

: [tunerlist]
  cr
  cr ." LIST A:"
  cr ."   guitar           ukelele           banjo            bass       "
  cr ."   violin           viola           cello              <empty>     "
  cr ."   Rest are empty scales "
  cr
;

\ ------------------------------------
: help-scales
  cr ." Scales (help-scales)"
  cr ." --------------------"
  cr ." Scale creation:"
  cr ."    create <scale-name> <notes> nlen<14  save-scale"
  cr ."    <scale-name> semi# transpose-scale"
  cr ."    load-scale"
  cr ." Scale library:"
  cr ."    Western scales: (Flats - BEADG)"
  cr ."         cstd (0flat) fmaj (1flat) b%maj (2flats) e%maj (3flats)"
  cr ."         a%maj (4flats) d%maj (5flats)"
  cr ."         4flats-stairway  5flats-dream"
  cr ."         cmaj dmin"
  cr ."    Non-Western scales (equitempered)"
  cr ."         irish phyrigian algerian balinese chinese mongolian yuG-approx "
  cr ."         Indian (8): bhairav, asavari, bhairavi, kafi, khamaj, kalyan, purvi, todi"
  cr ."         Arabic: jins-hijaz jins-kurd jins-lami"
  cr ."    Exotic Frequencies (different base frequencies)"
  cr ."         Chinese (5): yu yu-1(*) shang gong jue zhi"
  cr ."    Instrument tunings:"
  cr ."         guitar  bass   ukelele   violin  cello  viola"
\ TODO: Are the Chinese exotic frequencies based on quarter tones??
\ TODO: Add Arabic quarter tone scales
;

help-scales


\ ============== REFERENCES

\  2020-07-10---Fri---03:14 AKE

\  [1] Musical scales: explained
\  https://web.archive.org/web/20191029131100/http://pages.iu.edu/~kforinas/S/15MusicalScales.html

\  Mathematical perspective: the musical scale is multiplicative -- there are 12 semitones in an octave, and each octave is double the frequency of the one below.  Based on this, the frequency ratio between successive semitone is 12th-root of 2 = 2^(1/12) = 1.05946309436, or a FIXED ~6% increase in frequency from note to note.  This is called the "equi-tempered" system popularized by Bach.

\  Equal temperament system: 
\  https://en.wikipedia.org/wiki/Equal_temperament
\  
\  Bach and Equal Temperament (paper):
\  https://www.academia.edu/3368760/Rosetta_Revisited_Bachs_Very_Ordinary_Temperament
\  
\  WESTERN & EXOTIC SCALES CATALOG
\  [2] 12 musical scales and backing tracks
\  https://www.pianoscales.org/major.html
\  
\  Western major scale:
\  7 notes
\  Do Re Mi Fa So La Ti
\  
\  Arab system: 24-TET
\  https://en.wikipedia.org/wiki/Equal_temperament
\  
\  Chinese musical system: 
\  https://simple.wikipedia.org/wiki/Chinese_musical_system
\  
\  
\  Ginan musical scales:
\  Special Subjects in Music Theory, by Catherine Schmidt-Jones
\  Indian music: https://cnx.org/contents/mviDomhA@5.66:bDLyHWWs@16/Indian-Classical-Music-Tuning-and-Ragas
\  Karnatic raga  (South India)
\      https://en.wikipedia.org/wiki/Carnatic_raga
\  Hindustani (North India)
\  Tantric
\  Sufic
\  
\  Indian musical system:
\  7 notes (swaras)
\  Sa Ri Ga Ma Pa Dha Ni
\  
\  A bit too conspiracy theoriest for my taste, but interesting:
\  	https://ray.tomes.biz/alex.htm
\  
\  https://books.google.co.uk/books?id=Ad7dDAAAQBAJ&pg=PA100&lpg=PA100&dq=ginan+musical+scales&source=bl&ots=oDxlk787DN&sig=ACfU3U0RSI8Ir4ai8Dt42hJjpsGRBjZ5Bg&hl=en&sa=X&ved=2ahUKEwiTj-7ngMXqAhWFQxUIHdfkA3kQ6AEwAHoECA0QAQ#v=onepage&q=ginan%20musical%20scales&f=false


\ ============================================
\ V5 2021-08-17---Tue---21:23 - encoded Chinese scales directly into frequency tables, added many exotic scales
\ V6 2021-09-04---Sat---08:10 - made consistent with major revision of how scales are entered.  Streamlined instrument tunings to be only those notes (4,6 etc)
\ V7 2021-10-07---Thu---02:59 - COMPLETED: Music scales - added the circle of fifth scales, some exotics, and japanese scales


\ TODO: light up scales on normal piano board
\ TODO: add quarter tone scales for arabic music!



